| The Gaudi Framework v32r1 (f65d50dc)

Public Member Functions | Protected Member Functions | Private Attributes | List of all members
Tuples::Tuple Class Reference

A simple wrapper class over standard Gaudi NTuple::Tuple facility. More...

`#include <GaudiAlg/Tuple.h>`

Collaboration diagram for Tuples::Tuple:
[legend]

## Public Member Functions
| Tuple (std::shared_ptr< TupleObj > tuple)
| standard constructor More...
virtual | ~Tuple ()=default
TupleObj * | operator-> () const
| get the pointer to the underlying object More...
bool | valid () const
| check the validity of the tuple object More...

## Protected Member Functions
TupleObj * | tuple ()

## Private Attributes
std::shared_ptr< TupleObj > | m_tuple
| The (shared) tuple object. More...

## Detailed Description

A simple wrapper class over standard Gaudi NTuple::Tuple facility.

The main advantages of local ntuples with respect to 'standard' Gaudi NTuples ( NTuple::Tuple ) is their "locality". For 'standard' ntuples one need

1. Define all ntuple columns/items as data members of the algorithm
2. Book the `NTuple::Tuple` object using `INTupleSvc`
3. Add all defined columns/items to the booked ntuple
4. Fill ntuple records

Usually the first step is done in the header file (separate file!) of the algorithm, the second and the third steps are done in `initialize()` method of the algorithm and the fourth step is done somewhere in `execute()` method of the same algorithm. Such approach requires to keep track of the tuple structure through different method and event through different files. And even minor modification of the structure of the ntuple will require the modification of at least 2 methods and 2 files.

The `Tuples::Tuple` wrapper over standard Gaudi `NTuple::Tuple` class solves all above listed problems with "non-local" nature of Gaudi `NTuple::Tuple` objects.

`Tuples::Tuple` object is booked and used 'locally'. One does not need to pre-book the ntuple or its columns/items somewhere in different compilation units or other methods different from the actual point of using the ntuple.

The simplest example of usage Tuple object:

Tuple tuple = nTuple( "some more or less unique tuple title ");
for( Loop D0 = loop( "K- pi+", "D0" ) , D0 , ++D0 )
{
tuple -> column ( "mass" , M ( D0 ) / GeV ) ;
tuple -> column ( "pt" , PT ( D0 ) / GeV ) ;
tuple -> column ( "p" , P ( D0 ) / GeV ) ;
tuple -> write () ;
}

One could fill some Tuple variables in one go

Tuple tuple = nTuple( "some more or less unique tuple title ");
for( Loop D0 = loop( "K- pi+", "D0" ) , D0 , ++D0 )
{
tuple -> column ( "mass" , M ( D0 ) / GeV ) ;
tuple -> fill ( "pt , p " , PT ( D0 ) / GeV , P(D0) / GeV ) ;
tuple -> write () ;
}

Even ALL variables could be filled in one go:

Tuple tuple = nTuple( "some more or less unique tuple title ");
for( Loop D0 = loop( "K- pi+", "D0" ) , D0 , ++D0 )
{
tuple -> fill ( "mass pt , p ", M(D0)/GeV,PT(D0)/GeV,P(D0)/GeV ) ;
tuple -> write () ;
}

All these techniques could be easily combined in arbitrary ways

See also
  GaudiTupleAlg
  TupleObj

Author
  Vanya BELYAEV Ivan..nosp@m.Bely.nosp@m.aev@i.nosp@m.tep..nosp@m.ru

Date
  2003-02-24

Definition at line 116 of file Tuple.h.

## Constructor & Destructor Documentation

## ◆ Tuple()

Tuples::Tuple::Tuple | ( | std::shared_ptr< TupleObj > | tuple | ) |
| inline

standard constructor

Parameters

  tuple | pointer to "real" tuple object

Definition at line 122 of file Tuple.h.

122 : m_tuple( std::move( tuple ) ) {}
Tuples::Tuple::tuple
TupleObj * tuple()
Definition: Tuple.h:135
Tuples::Tuple::m_tuple
std::shared_ptr< TupleObj > m_tuple
The (shared) tuple object.
Definition: Tuple.h:139
std::move
T move(T... args)

## ◆ ~Tuple()

virtual Tuples::Tuple::~Tuple | ( |  | ) |
| virtual default

## Member Function Documentation

## ◆ operator->()

TupleObj* Tuples::Tuple::operator-> | ( |  | ) | const
| inline

get the pointer to the underlying object

Returns
  pointer to underlying TupleObj

Definition at line 129 of file Tuple.h.

129 { return m_tuple.get(); }
Tuples::Tuple::m_tuple
std::shared_ptr< TupleObj > m_tuple
The (shared) tuple object.
Definition: Tuple.h:139

## ◆ tuple()

TupleObj* Tuples::Tuple::tuple | ( |  | ) |
| inline protected

Definition at line 135 of file Tuple.h.

135 { return m_tuple.get(); }
Tuples::Tuple::m_tuple
std::shared_ptr< TupleObj > m_tuple
The (shared) tuple object.
Definition: Tuple.h:139

## ◆ valid()

bool Tuples::Tuple::valid | ( |  | ) | const
| inline

check the validity of the tuple object

Definition at line 132 of file Tuple.h.

132 { return static_cast<bool>( m_tuple ); }
Tuples::Tuple::m_tuple
std::shared_ptr< TupleObj > m_tuple
The (shared) tuple object.
Definition: Tuple.h:139

## Member Data Documentation

## ◆ m_tuple

std::shared_ptr<TupleObj> Tuples::Tuple::m_tuple
| private

The (shared) tuple object.

Definition at line 139 of file Tuple.h.

The documentation for this class was generated from the following file:

- GaudiAlg/GaudiAlg/Tuple.h